Subject: Re: [Ibnemo] [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

From: Zhoutianran <[email-masked]>
Date: Tue, 12 May 2015 06:41:16 +0000

Hi Albrecht,

Your comments let me think about the relationship between service description and the policy specification.
The commented draft related to a currently hot topic called "intent", which provides a high level description of requirements to network with the abstraction from top down. 
The PSL you listed:
1. Seems talk about many separated aspects. How do they related each other under the topic of policy specification? This also come to another question: what's the policy definition?
2. Do you think the network intent equals the policy?

May be the requirement here is that we need network intent modeling and an intent expression language.

Best Regards,
Terence

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Friday, May 08, 2015 11:51 PM
To: Natale, Bob; Xiayinben
Cc: [email-masked]
Subject: Re: [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Bob, Yinben,

the specific PSL depends primarily on your requirements concerning
a) policy rule conditions (i.e., what kind of condifition, what levels of details concerning packet flow identification etc) and
b) policy rule actions (i.e., what type of actions needs to be supported).

Yinben:
your two PSL examples got routing in scope, i.e., relatively simple policy conditions and focused policy actions on routing only.

Bob:
below a list of PSLs which were part of DPI related work in ITU-T SG13 (=> Y.2770) and SG16 (=> H.248.86 https://www.itu.int/rec/dologin_pub.asp?lang=e&id=T-REC-H.248.86-201401-I!!PDF-E&type=items ; see Appendix IV and Bibliography):

Table IV.1 – Example list of policy specification languages (PSLs) (also known as policy expression languages (PELs) or filter specification languages (FSLs))
No	Policy specification language	Reference
1	SNORT	[b-SNORT]
2	SAML – Security Assertion Markup Language (SAML 2.0) 	[b-ITU-T X.1141] 
3	XACML – eXtensible Access Control Markup Language (XACML 2.0) 	[b-ITU-T X.1142] 
4	Open Service Access (OSA) Application Programming Interface (API); Part 13: Policy management Service Capability Feature (SCF)	[b-3GPP 29.198-13]
5	SIEVE – An Email Filtering Language	[b-IETF RFC 5228]
6	BPEL – Business Process Expression Language	[b-OASIS BPEL]
7	BPML – Business Process Modeling Language 	[b-OMG BPML] 
8	XCAP – XML Configuration Access Protocol	[b-IETF RFC 4825]
9	PEEM Policy Expression Language (by Open Mobile Alliance)	[b-OMA PEEM]
10	PacketTypes 	[b-PacketTypes]
11	APF – A Packet Filter	[b-APF]
12	RTAG – Real-Time Asynchronous Grammars	[b-RTAG]
13	TAP/APC – Timed Abstract Protocol & Austin Protocol Compiler	[b-TAP]
14	GAPAL – Generic Application-Level Protocol Analyzer and its Language	[b-GAPAL]
15	Perl (Compatible) Regular Expressions	
16	POSIX Regular Expressions	

It is obvious that DPI requires the most extensive and detailed policy conditions, - and the set of policy actions covers all usual policies related to packet treatment (incl. routing!).

Furthermore: if you go down from the level of languages to protocols, then there are again many options to map a concrete PSL on a particular protocol ...

Regards,
Albrecht

-----Original Message-----
From: Natale, Bob [mailto:[email-masked]]
Sent: Mittwoch, 6. Mai 2015 08:58
To: Schwarz, Albrecht (Albrecht)
Subject: PSLs [was RE: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Hi Albrecht,

If you happen to have a list (or pointer to one) of those 20+ PSLs (or even a subset of them), I would greatly appreciate receiving that information.

Avanti,
BobN

-----Original Message-----
From: Xiayinben [mailto:[email-masked]]
Sent: Mittwoch, 6. Mai 2015 03:33
To: Schwarz, Albrecht (Albrecht); [email-masked]; [email-masked]
Subject: 答复: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Hi Albrecht,

Thanks for your suggestion, we will consider your suggestion to add a section to explain the relationship with prior arts.
Here I give some quick answer to your comments.
As I reply to Huub, this draft focus on how to easily describe the intent of customer manipulating network.
The customers only want to describe the result they want to get rather than the implementation instructions. And customer's intent is not only for control the traffic but also request resource.
PSLs such as RFC2622/RFC4012 are specific instructions for routing control. They are not customer's intent.
I think it is still short of a language which can simply describe customer manipulating intent. Let's continue this discussion. Any comments are welcome.

Thanks a lot.

Yinben

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Tuesday, May 05, 2015 6:00 AM
To: [email-masked]; [email-masked]
Subject: Re: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Appreciate your comment Huub!
Like to make a comment in a similar direction:
The draft should provide an explicit section on sth like "Inventory of existing languages" in that field, after the requirements section (clause 3) and the language design section (current clause 4) because there are already a plenty of languages in that field!
SDN is all about the control of traffic flows based on packets, i.e., all existing languages in that area a firstly applicable as "service description language" (at the southband interface).
Such kind of languages are known as
- policy specification languages (PSL), or
- policy  expression  languages  (PEL)  or
- filter  specification  languages  (FSL) or
- sth similar.
There are already more than 20 PSLs (to my knowldege).
The notion of "language" indicates a) a level of abstraction and b) the need for a final compilation/interpretation for its usage in a packet processing element.

The indicated examples seems to express typical configurations in such PSLs.
Thus, the draft needs a strong justification "why another language" in that field.

My cents,
Albrecht

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Huub van Helvoort
Sent: Dienstag, 5. Mai 2015 10:26
To: [email-masked]
Subject: Re: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Authors:

Just to avoid any confusion: I assume this is *not* the Specification and Description Language (SDL) described by the ITU-T in recommendations
Z.100  http://www.itu.int/ITU-T/recommendations/rec.aspx?rec=11387

Regards, Huub.

--------------

On 04-05-15 11:59, [email-masked] wrote:
>
> A New Internet-Draft is available from the on-line Internet-Drafts directories.
>
>
>          Title           : Requirements for a Service Description Language and Design Considerations
>          Authors         : Yinben Xia
>                            Sheng Jiang
>                            Susan Hares
> 	Filename        : draft-xia-sdnrg-service-description-language-02.txt
> 	Pages           : 7
> 	Date            : 2015-05-04
>
> Abstract:
>     The more and more complicated IP networks require a new interaction
>     mechanism between their customers and their networks.  A service
>     description language is needed to enable customers to easily describe
>     their diverse intent.  SDN controller would compile the user intent
>     into device configurations.  This document analyzes requirements for
>     such service description language and gives considerations for
>     designing such service description language.
>
>
> The IETF datatracker status page for this draft is:
> https://datatracker.ietf.org/doc/draft-xia-sdnrg-service-description-l
> anguage/
>
> There's also a htmlized version available at:
> https://tools.ietf.org/html/draft-xia-sdnrg-service-description-langua
> ge-02
>
> A diff from the previous version is available at:
> https://www.ietf.org/rfcdiff?url2=draft-xia-sdnrg-service-description-
> language-02
>
>
> Please note that it may take a couple of minutes from the time of 
> submission until the htmlized version and diff are available at tools.ietf.org.
>
> Internet-Drafts are also available by anonymous FTP at:
> ftp://ftp.ietf.org/internet-drafts/
>
> _______________________________________________
> I-D-Announce mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/i-d-announce
> Internet-Draft directories: http://www.ietf.org/shadow.html or 
> ftp://ftp.ietf.org/ietf/1shadow-sites.txt
>

--
*****************************************************************
               请记住，你是独一无二的，就像其他每一个人一样

_______________________________________________
sdn mailing list
[email-masked]
https://www.irtf.org/mailman/listinfo/sdn
_______________________________________________
sdn mailing list
[email-masked]
https://www.irtf.org/mailman/listinfo/sdn
_______________________________________________
sdn mailing list
[email-masked]
https://www.irtf.org/mailman/listinfo/sdn

---

From: Zhoutianran <[email-masked]>
Date: Thu, 14 May 2015 17:08:08 +0000

Hi Albrecht,

You information on policy really helps. I am not going to redefine the policy. And we are acturally trying to follow the policy definition in the industry, e.g. condition, action, if you have a look at the language draft (https://tools.ietf.org/html/draft-xia-sdnrg-nemo-language-02).

All the work we are doing is to research the intent concept implementing a lot in opensource area, e.g. ONOS, and Opendayligt GBP, NIC, NEMO. That's also why we have a "intent based network modeling" ([email-masked]) mailing list.

IMHO the "intent" is not only the policy. But it's not clear defined, on which I think we can collect intelligence from the community. 

Best,
Terence

________________________________________
发件人: Schwarz, Albrecht (Albrecht) [[email-masked]]
发送时间: 2015年5月13日 21:16
收件人: Zhoutianran; Natale, Bob; Xiayinben
抄送: [email-masked]; [email-masked]
主题: RE: [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Terence,

wrt
> : what's the policy definition?

Software Defined Network deal about the control and configuration of packet based networks, at least concerning current communication technologies.
We may use the abstract notation of a packet, independent of specific protocol layers ("let's say from transmission layer up to application layers").
Consequently, policy or policy rule is tightly coupled to the handling of packets (usually a series of packets, i.e., a packet flow).
Hence, you got a framework which policy definitions would be applicable.
For instance, RFC 3198 in case of packet (flow) related policy rules / policies.

Briefly, a policy RULE is the  binding  of  a  set  of  ACTIONS  to  a  set  of  CONDITIONS.
Here you go.

You did apply that scheme already in your draft, see e.g.

      Policy policy1_id
         Appliesto flow1_id
         Action "forwardto", connection1_id

      Flow flow1_id
         Match "srcip","192.0.2.0/24","dstip","198.51.100.0/24","Port",
               "55555"
         Property "NAME", "CDN sync flow", "Bidirection","true"

=> Policy rule CONDITION(s): given by flow1_id ...
=> Policy rule ACTION(s): given by Action ...
And there are additional surrounding rule attributes such as names, identifiers, etc, - again as also in your example.

Thus, the baseline of your draft should be RFC 3198 related policy terms.

Regards,
Albrecht

-----Original Message-----
From: Zhoutianran [mailto:[email-masked]]
Sent: Dienstag, 12. Mai 2015 08:41
To: Schwarz, Albrecht (Albrecht); Natale, Bob; Xiayinben
Cc: [email-masked]; [email-masked]
Subject: RE: [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Hi Albrecht,

Best Regards,
Terence

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Friday, May 08, 2015 11:51 PM
To: Natale, Bob; Xiayinben
Cc: [email-masked]
Subject: Re: [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Bob, Yinben,

Yinben:

Bob:

Regards,
Albrecht

-----Original Message-----
From: Natale, Bob [mailto:[email-masked]]
Sent: Mittwoch, 6. Mai 2015 08:58
To: Schwarz, Albrecht (Albrecht)
Subject: PSLs [was RE: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Hi Albrecht,

Avanti,
BobN

-----Original Message-----
From: Xiayinben [mailto:[email-masked]]
Sent: Mittwoch, 6. Mai 2015 03:33
To: Schwarz, Albrecht (Albrecht); [email-masked]; [email-masked]
Subject: 答复: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Hi Albrecht,

Thanks a lot.

Yinben

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Tuesday, May 05, 2015 6:00 AM
To: [email-masked]; [email-masked]
Subject: Re: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

My cents,
Albrecht

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Huub van Helvoort
Sent: Dienstag, 5. Mai 2015 10:26
To: [email-masked]
Subject: Re: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Authors:

Regards, Huub.

--------------

---

From: "Schwarz, Albrecht (Albrecht)" <[email-masked]>
Date: Wed, 13 May 2015 13:16:01 +0000

Terence,

wrt

      Policy policy1_id
         Appliesto flow1_id

      Flow flow1_id

Regards,
Albrecht

-----Original Message-----
From: Zhoutianran [mailto:[email-masked]] 
Sent: Dienstag, 12. Mai 2015 08:41
To: Schwarz, Albrecht (Albrecht); Natale, Bob; Xiayinben
Cc: [email-masked]; [email-masked]
Subject: RE: [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Hi Albrecht,

Best Regards,
Terence

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Friday, May 08, 2015 11:51 PM
To: Natale, Bob; Xiayinben
Cc: [email-masked]
Subject: Re: [Sdn] PSLs [was RE: I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Bob, Yinben,

Yinben:

Bob:

Regards,
Albrecht

-----Original Message-----
From: Natale, Bob [mailto:[email-masked]]
Sent: Mittwoch, 6. Mai 2015 08:58
To: Schwarz, Albrecht (Albrecht)
Subject: PSLs [was RE: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt]

Hi Albrecht,

Avanti,
BobN

-----Original Message-----
From: Xiayinben [mailto:[email-masked]]
Sent: Mittwoch, 6. Mai 2015 03:33
To: Schwarz, Albrecht (Albrecht); [email-masked]; [email-masked]
Subject: 答复: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Hi Albrecht,

Thanks a lot.

Yinben

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Schwarz, Albrecht (Albrecht)
Sent: Tuesday, May 05, 2015 6:00 AM
To: [email-masked]; [email-masked]
Subject: Re: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

My cents,
Albrecht

-----Original Message-----
From: sdn [mailto:[email-masked]] On Behalf Of Huub van Helvoort
Sent: Dienstag, 5. Mai 2015 10:26
To: [email-masked]
Subject: Re: [Sdn] I-D Action: draft-xia-sdnrg-service-description-language-02.txt

Authors:

Regards, Huub.

--------------